All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
7 mr - a Multiple Repository management tool
11 B<mr> [options] checkout
13 B<mr> [options] update
15 B<mr> [options] status
17 B<mr> [options] commit [-m "message"]
23 B<mr> [options] register [repository]
25 B<mr> [options] config section ["parameter=[value]" ...]
27 B<mr> [options] action [params ...]
31 B<mr> is a Multiple Repository management tool. It
32 can checkout, update, or perform other actions on
33 a set of repositories as if they were one combined respository. It
34 supports any combination of subversion, git, cvs, and bzr repositories,
35 and support for other revision control systems can easily be added.
37 B<mr> cds into and operates on all registered repositories at or below your
38 working directory. Or, if you are in a subdirectory of a repository that
39 contains no other registered repositories, it will stay in that directory,
40 and work on only that repository,
42 These predefined commands should be fairly familiar to users of any revision
47 =item checkout (or co)
49 Checks out any repositories that are not already checked out.
53 Updates each repository from its configured remote repository.
55 If a repository isn't checked out yet, it will first check it out.
59 Displays a status report for each repository, showing what
60 uncommitted changes are present in the repository.
64 Commits changes to each repository. (By default, changes are pushed to the
65 remote repository too, when using distributed systems like git.)
67 The optional -m parameter allows specifying a commit message.
71 Show a diff of uncommitted changes.
79 These commands are also available:
85 List the repositories that mr will act on.
89 Register an existing repository in a mrconfig file. By default, the
90 repository in the current directory is registered, or you can specify a
91 directory to register.
93 The mrconfig file that is modified is chosen by either the -c option, or by
94 looking for the closest known one at or below the current directory.
98 Adds, modifies, removes, or prints a value from a mrconfig file. The next
99 parameter is the name of the section the value is in. To add or modify
100 values, use one or more instances of "parameter=value". Use "parameter=" to
101 remove a parameter. Use just "parameter" to get the value of a parameter.
103 For example, to add (or edit) a repository in src/foo:
105 mr config src/foo checkout="svn co svn://example.com/foo/trunk foo"
107 To show the command that mr uses to update the repository in src/foo:
109 mr config src/foo update
111 The ~/.mrconfig file is used by default. To use a different config file,
120 Actions can be abbreviated to any unambiguous subsctring, so
121 "mr st" is equivilant to "mr status", and "mr up" is equivilant to "mr
124 Additional parameters can be passed to most commands, and are passed on
125 unchanged to the underlying revision control system. This is mostly useful
126 if the repositories mr will act on all use the same revision control
135 Specifies the topmost directory that B<mr> should work in. The default is
136 the current working directory.
140 Use the specified mrconfig file. The default is B<~/.mrconfig>
148 Expand the statistics line displayed at the end to include information
149 about exactly which repositories failed and were skipped, if any.
153 Just operate on the repository for the current directory, do not
154 recurse into deeper repositories.
160 B<mr> is configured by .mrconfig files. It starts by reading the .mrconfig
161 file in your home directory, and this can in turn chain load .mrconfig files
164 Here is an example .mrconfig file:
167 checkout = svn co svn://svn.example.com/src/trunk src
171 checkout = git clone git://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux-2.6.git &&
173 git checkout -b mybranch origin/master
175 The .mrconfig file uses a variant of the INI file format. Lines starting with
176 "#" are comments. Values can be continued to the following line by
177 indenting the line with whitespace.
179 The "DEFAULT" section allows setting default values for the sections that
182 The "ALIAS" section allows adding aliases for actions. Each parameter
183 is an alias, and its value is the action to use.
185 All other sections add repositories. The section header specifies the
186 directory where the repository is located. This is relative to the directory
187 that contains the mrconfig file, but you can also choose to use absolute
190 Within a section, each parameter defines a shell command to run to handle a
191 given action. mr contains default handlers for "update", "status",
192 "commit", and other standard actions. Normally you only need to specify what
193 to do for "checkout".
195 Note that these shell commands are run in a "set -e" shell
196 environment, where any additional parameters you pass are available in
197 "$@". The "checkout" command is run in the parent of the repository
198 directory, since the repository isn't checked out yet. All other commands
199 are run inside the repository, though not necessarily at the top of it.
201 The "MR_REPO" environment variable is set to the path to the top of the
202 repository. The "MR_CONFIG" environment variable is set to the .mrconfig file
203 that defines the repo being acted on, or, if the repo is not yet in a config
204 file, the .mrconfig file that should be modified to register the repo.
206 A few parameters have special meanings:
212 If the "skip" parameter is set and its command returns true, then B<mr>
213 will skip acting on that repository. The command is passed the action
216 Here are two examples. The first skips the repo unless
217 mr is run by joey. The second uses the hours_since function
218 (included in mr's built-in library) to skip updating the repo unless it's
219 been at least 12 hours since the last update.
221 skip = test $(whoami) != joey
222 skip = [ "$1" = update ] && [ $(hours_since "$1") -lt 12 ]
226 If the "chain" parameter is set and its command returns true, then B<mr>
227 will try to load a .mrconfig file from the root of the repository. (You
228 should avoid chaining from repositories with untrusted committers.)
232 The "lib" parameter can specify some shell code that will be run before each
233 command, this can be a useful way to define shell functions for other commands
240 Copyright 2007 Joey Hess <joey@kitenet.net>
242 Licensed under the GNU GPL version 2 or higher.
244 http://kitenet.net/~joey/code/mr/
253 use Cwd qw(getcwd abs_path);
256 print STDERR "mr: interrupted\n";
260 $ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
261 my $config_overridden=0;
262 my $directory=getcwd();
271 Getopt::Long::Configure("no_permute");
272 my $result=GetOptions(
273 "d|directory=s" => sub { $directory=abs_path($_[1]) },
274 "c|config=s" => sub { $ENV{MR_CONFIG}=$_[1]; $config_overridden=1 },
275 "v|verbose" => \$verbose,
276 "s|stats" => \$stats,
277 "n|no-recurse" => \$no_recurse,
279 if (! $result || @ARGV < 1) {
280 die("Usage: mr [-d directory] action [params ...]\n".
281 "(Use mr help for man page.)\n");
285 # Make sure MR_CONFIG is an absolute path, but don't use abs_path since
286 # the config file might be a symlink to elsewhere, and the directory it's
288 if ($ENV{MR_CONFIG} !~ /^\//) {
289 $ENV{MR_CONFIG}=getcwd()."/".$ENV{MR_CONFIG};
293 loadconfig($ENV{MR_CONFIG});
295 #print Dumper(\%config);
298 use FindBin qw($Bin $Script);
299 $ENV{MR_PATH}=$Bin."/".$Script;
302 # alias expansion and command stemming
303 my $action=shift @ARGV;
304 if (exists $alias{$action}) {
305 $action=$alias{$action};
307 if (! exists $knownactions{$action}) {
308 my @matches = grep { /^\Q$action\E/ }
309 keys %knownactions, keys %alias;
313 elsif (@matches == 0) {
314 die "mr: unknown action \"$action\" (known actions: ".
315 join(", ", sort keys %knownactions).")\n";
318 die "mr: ambiguous action \"$action\" (matches: ".
319 join(", ", @matches).")\n";
323 # commands that do not operate on all repos
324 if ($action eq 'help') {
325 exec($config{''}{DEFAULT}{$action}) || die "exec: $!";
327 elsif ($action eq 'config') {
329 die "mr config: not enough parameters\n";
332 if ($section=~/^\//) {
333 # try to convert to a path relative to the config file
334 my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
336 $dir.="/" unless $dir=~/\/$/;
337 if ($section=~/^\Q$dir\E(.*)/) {
343 if (/^([^=]+)=(.*)$/) {
344 $changefields{$1}=$2;
348 foreach my $topdir (sort keys %config) {
349 if (exists $config{$topdir}{$section} &&
350 exists $config{$topdir}{$section}{$_}) {
351 print $config{$topdir}{$section}{$_}."\n";
353 last if $section eq 'DEFAULT';
357 die "mr $action: $section $_ not set\n";
361 modifyconfig($ENV{MR_CONFIG}, $section, %changefields) if %changefields;
364 elsif ($action eq 'register') {
365 if (! $config_overridden) {
366 # Find the closest known mrconfig file to the current
368 $directory.="/" unless $directory=~/\/$/;
369 foreach my $topdir (reverse sort keys %config) {
370 next unless length $topdir;
371 if ($directory=~/^\Q$topdir\E/) {
372 $ENV{MR_CONFIG}=$configfiles{$topdir};
377 my $command="set -e; ".$config{''}{DEFAULT}{lib}."\n".
378 "my_action(){ $config{''}{DEFAULT}{$action}\n }; my_action ".
379 join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
380 print STDERR "mr $action: running >>$command<<\n" if $verbose;
381 exec($command) || die "exec: $!";
384 # work out what repos to act on
387 foreach my $topdir (sort keys %config) {
388 foreach my $subdir (sort keys %{$config{$topdir}}) {
389 next if $subdir eq 'DEFAULT';
390 my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
392 $dir.="/" unless $dir=~/\/$/;
393 $d.="/" unless $d=~/\/$/;
394 next if $no_recurse && $d ne $dir;
395 next if $dir ne $d && $dir !~ /^\Q$d\E/;
396 push @repos, [$dir, $topdir, $subdir];
400 # fallback to find a leaf repo
401 LEAF: foreach my $topdir (reverse sort keys %config) {
402 foreach my $subdir (reverse sort keys %{$config{$topdir}}) {
403 next if $subdir eq 'DEFAULT';
404 my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
406 $dir.="/" unless $dir=~/\/$/;
407 $d.="/" unless $d=~/\/$/;
408 if ($d=~/^\Q$dir\E/) {
409 push @repos, [$dir, $topdir, $subdir];
417 my (@failed, @ok, @skipped);
418 foreach my $repo (@repos) {
419 action($action, @$repo);
423 my ($action, $dir, $topdir, $subdir) = @_;
425 $ENV{MR_CONFIG}=$configfiles{$topdir};
426 my $lib=exists $config{$topdir}{$subdir}{lib} ?
427 $config{$topdir}{$subdir}{lib}."\n" : "";
429 if ($action eq 'checkout') {
431 print "mr $action: $dir already exists, skipping checkout\n" if $verbose;
436 $dir=~s/^(.*)\/[^\/]+\/?$/$1/;
439 print "mr $action: creating parent directory $dir\n" if $verbose;
440 my $ret=system("mkdir", "-p", $dir);
443 elsif ($action eq 'update') {
445 return action("checkout", $dir, $topdir, $subdir);
451 if (exists $config{$topdir}{$subdir}{skip}) {
452 my $test="set -e;".$lib.
453 "my_action(){ $config{$topdir}{$subdir}{skip}\n }; my_action '$action'";
454 print "mr $action: running skip test >>$test<<\n" if $verbose;
455 my $ret=system($test);
457 if (($? & 127) == 2) {
458 print STDERR "mr $action: interrupted\n";
462 print STDERR "mr $action: skip test received signal ".($? & 127)."\n";
466 if ($ret >> 8 == 0) {
467 print "mr $action: $dir skipped per config file\n" if $verbose;
473 if (! $nochdir && ! chdir($dir)) {
474 print STDERR "mr $action: failed to chdir to $dir: $!\n";
477 elsif (! exists $config{$topdir}{$subdir}{$action}) {
478 print STDERR "mr $action: no defined $action command for $topdir$subdir, skipping\n";
483 print "mr $action: $topdir$subdir\n";
486 print "mr $action: $topdir$subdir (in subdir $directory)\n";
488 my $command="set -e; ".$lib.
489 "my_action(){ $config{$topdir}{$subdir}{$action}\n }; my_action ".
490 join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
491 print STDERR "mr $action: running >>$command<<\n" if $verbose;
492 my $ret=system($command);
494 if (($? & 127) == 2) {
495 print STDERR "mr $action: interrupted\n";
499 print STDERR "mr $action: received signal ".($? & 127)."\n";
501 print STDERR "mr $action: failed ($ret)\n" if $verbose;
503 if ($ret >> 8 != 0) {
504 print STDERR "mr $action: command failed\n";
507 print STDERR "mr $action: command died ($ret)\n";
511 if ($action eq 'checkout' && ! -d $dir) {
512 print STDERR "mr $action: $dir missing after checkout\n";;
529 return "$count ".($count > 1 ? $plural : $singular);
533 if (! @ok && ! @failed && ! @skipped) {
534 die "mr $action: no repositories found to work on\n";
536 print "mr $action: finished (".join("; ",
537 showstat($#ok+1, "ok", "ok"),
538 showstat($#failed+1, "failed", "failed"),
539 showstat($#skipped+1, "skipped", "skipped"),
543 print "mr $action: (skipped: ".join(" ", @skipped).")\n";
546 print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
552 elsif (! @ok && @skipped) {
558 sub loadconfig { #{{{
565 if (ref $f eq 'GLOB') {
574 my $absf=abs_path($f);
575 if ($loaded{$absf}) {
580 ($dir)=$f=~/^(.*\/)[^\/]+$/;
581 if (! defined $dir) {
584 $dir=abs_path($dir)."/";
586 if (! exists $configfiles{$dir}) {
587 $configfiles{$dir}=$f;
590 # copy in defaults from first parent
592 while ($parent=~s/^(.*\/)[^\/]+\/?$/$1/) {
593 if ($parent eq '/') {
596 if (exists $config{$parent} &&
597 exists $config{$parent}{DEFAULT}) {
598 $config{$dir}{DEFAULT}={ %{$config{$parent}{DEFAULT}} };
603 print "mr: loading config $f\n" if $verbose;
604 open($in, "<", $f) || die "mr: open $f: $!\n";
615 next if /^\s*\#/ || /^\s*$/;
616 if (/^\[([^\]]*)\]\s*$/) {
619 elsif (/^(\w+)\s*=\s*(.*)/) {
624 while (@lines && $lines[0]=~/^\s(.+)/) {
631 if (! defined $section) {
632 die "$f line $.: parameter ($parameter) not in section\n";
634 if ($section ne 'ALIAS' &&
635 ! exists $config{$dir}{$section} &&
636 exists $config{$dir}{DEFAULT}) {
638 $config{$dir}{$section}={ %{$config{$dir}{DEFAULT}} };
640 if ($section eq 'ALIAS') {
641 $alias{$parameter}=$value;
643 elsif ($parameter eq 'lib') {
644 $config{$dir}{$section}{lib}.=$value."\n";
647 $config{$dir}{$section}{$parameter}=$value;
648 $knownactions{$parameter}=1;
649 if ($parameter eq 'chain' &&
650 length $dir && $section ne "DEFAULT" &&
651 -e $dir.$section."/.mrconfig") {
652 my $ret=system($value);
654 if (($? & 127) == 2) {
655 print STDERR "mr $action: chain test interrupted\n";
659 print STDERR "mr $action: chain test received signal ".($? & 127)."\n";
663 push @toload, $dir.$section."/.mrconfig";
669 die "$f line $line: parse error\n";
678 sub modifyconfig { #{{{
680 # the section to modify or add
681 my $targetsection=shift;
682 # fields to change in the section
683 # To remove a field, set its value to "".
690 open(my $in, "<", $f) || die "mr: open $f: $!\n";
695 my $formatfield=sub {
697 my @value=split(/\n/, shift);
699 return "$field = ".shift(@value)."\n".
700 join("", map { "\t$_\n" } @value);
704 while ($out[$#out] =~ /^\s*$/) {
705 unshift @blanks, pop @out;
707 foreach my $field (sort keys %changefields) {
708 if (length $changefields{$field}) {
709 push @out, "$field = $changefields{$field}\n";
710 delete $changefields{$field};
720 if (/^\s*\#/ || /^\s*$/) {
723 elsif (/^\[([^\]]*)\]\s*$/) {
724 if (defined $section &&
725 $section eq $targetsection) {
733 elsif (/^(\w+)\s*=\s(.*)/) {
738 while (@lines && $lines[0]=~/^\s(.+)/) {
744 if ($section eq $targetsection) {
745 if (exists $changefields{$parameter}) {
746 if (length $changefields{$parameter}) {
747 $value=$changefields{$parameter};
749 delete $changefields{$parameter};
753 push @out, $formatfield->($parameter, $value);
757 if (defined $section &&
758 $section eq $targetsection) {
761 elsif (%changefields) {
762 push @out, "\n[$targetsection]\n";
763 foreach my $field (sort keys %changefields) {
764 if (length $changefields{$field}) {
765 push @out, $formatfield->($field, $changefields{$field});
770 open(my $out, ">", $f) || die "mr: write $f: $!\n";
775 # Finally, some useful actions that mr knows about by default.
776 # These can be overridden in ~/.mrconfig.
791 for dir in .git .svn .bzr CVS; do
792 if [ -e "$MR_REPO/$dir" ]; then
793 flagfile="$MR_REPO/$dir/.mr_last$1"
797 if [ -z "$flagfile" ]; then
798 error "cannot determine flag filename"
800 perl -wle 'print -f shift() ? int((-M _) * 24) : 9999' "$flagfile"
805 if [ -d "$MR_REPO"/.svn ]; then
807 elif [ -d "$MR_REPO"/.git ]; then
808 git pull origin master "$@"
809 elif [ -d "$MR_REPO"/.bzr ]; then
811 elif [ -d "$MR_REPO"/CVS ]; then
814 error "unknown repo type"
817 if [ -d "$MR_REPO"/.svn ]; then
819 elif [ -d "$MR_REPO"/.git ]; then
820 git status "$@" || true
821 elif [ -d "$MR_REPO"/.bzr ]; then
823 elif [ -d "$MR_REPO"/CVS ]; then
826 error "unknown repo type"
829 if [ -d "$MR_REPO"/.svn ]; then
831 elif [ -d "$MR_REPO"/.git ]; then
832 git commit -a "$@" && git push --all
833 elif [ -d "$MR_REPO"/.bzr ]; then
834 bzr commit "$@" && bzr push
835 elif [ -d "$MR_REPO"/CVS ]; then
838 error "unknown repo type"
841 if [ -d "$MR_REPO"/.svn ]; then
843 elif [ -d "$MR_REPO"/.git ]; then
845 elif [ -d "$MR_REPO"/.bzr ]; then
847 elif [ -d "$MR_REPO"/CVS ]; then
850 error "unknown repo type"
853 if [ -d "$MR_REPO"/.svn ]; then
855 elif [ -d "$MR_REPO"/.git ]; then
857 elif [ -d "$MR_REPO"/.bzr ]; then
859 elif [ -d "$MR_REPO"/CVS ]; then
862 error "unknown repo type"
868 basedir="$(basename $(pwd))"
870 url=$(LANG=C svn info . | grep -i ^URL: | cut -d ' ' -f 2)
871 if [ -z "$url" ]; then
872 error "cannot determine svn url"
874 echo "Registering svn url: $url in $MR_CONFIG"
875 mr -c "$MR_CONFIG" config "$(pwd)" checkout="svn co $url $basedir"
876 elif [ -d .git ]; then
877 url=$(LANG=C git-config --get remote.origin.url)
878 if [ -z "$url" ]; then
879 error "cannot determine git url"
881 echo "Registering git url: $url in $MR_CONFIG"
882 mr -c "$MR_CONFIG" config "$(pwd)" checkout="git clone $url $basedir"
883 elif [ -d .bzr ]; then
884 url=$(cat .bzr/branch/parent)
885 if [ -z "$url" ]; then
886 error "cannot determine bzr url"
888 echo "Registering bzr url: $url in $MR_CONFIG"
889 mr -c "$MR_CONFIG" config "$(pwd)" checkout="bzr clone $url $basedir"
890 elif [ -d CVS ]; then
891 repo=$(cat CVS/Repository)
893 if [ -z "$root" ]; then
894 error "cannot determine cvs root"
896 echo "Registering cvs repository $repo at root $root"
897 mr -c "$MR_CONFIG" config "$(pwd)" \
898 checkout="cvs -d '$root' co -d $basedir $repo"
900 error "unable to register this repo type"
903 if [ ! -e "$MR_PATH" ]; then
904 error "cannot find program path"
906 (pod2man -c mr "$MR_PATH" | man -l -) || error "pod2man or man failed"
910 ed = echo "A horse is a horse, of course, of course.."
911 T = echo "I pity the fool."
912 right = echo "Not found."